﻿#include <windows.h>

#define IDC_BUTTON     1
#define IDC_EDIT       2
#define IDC_CHECKBOX   3
#define IDC_STATIC     4

#define IDM_NOWY    101
#define IDM_ZAMKNIJ 102
#define IDM_KOPIUJ  103
#define IDM_WKLEJ   104
#define IDM_WYTNIJ  105


LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
switch(msg)
    {
		static HWND hButton, hEdit, hCheckBox, hStatic;
		static HMENU hMenu, hSubMenu;
		case WM_CREATE:
			hEdit = CreateWindow(TEXT("EDIT"), TEXT("Wpisz tu tekst i wciśnij przycisk"), 
				WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL| WS_VSCROLL | WS_BORDER ,
				10, 10, 470, 240 , hwnd, (HMENU)IDC_EDIT, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);
			hStatic = CreateWindow(TEXT("STATIC"), TEXT("Hello world"), WS_CHILD | WS_VISIBLE | WS_BORDER,
				10, 260, 470, 240 , hwnd, (HMENU)IDC_STATIC, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);
			hButton = CreateWindow(TEXT("BUTTON"), TEXT("Kopiuj"), WS_CHILD | WS_VISIBLE,
				10, 510, 100, 30, hwnd, (HMENU)IDC_BUTTON, GetModuleHandle(NULL), NULL);
			hCheckBox = CreateWindow(TEXT("BUTTON"), TEXT("Włącz/wyłącz"), WS_CHILD | WS_VISIBLE | BS_CHECKBOX,
				220, 510, 200, 30, hwnd, (HMENU)IDC_CHECKBOX, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);


			hMenu = CreateMenu();
			hSubMenu = CreateMenu();
			AppendMenu(hSubMenu, MF_STRING, IDM_NOWY, TEXT("&Nowy"));
			AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hSubMenu, MF_STRING, IDM_ZAMKNIJ, TEXT("&Zamknij"));
			AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hSubMenu, TEXT("&Plik"));

			hSubMenu = CreateMenu();
			AppendMenu(hSubMenu, MF_STRING, IDM_KOPIUJ, TEXT("&Kopiuj"));
			AppendMenu(hSubMenu, MF_STRING, IDM_WKLEJ, TEXT("&Wklej"));
			AppendMenu(hSubMenu, MF_STRING, IDM_WKLEJ, TEXT("W&ytnij"));
			AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hSubMenu, TEXT("&Edytuj"));

			SetMenu(hwnd, hMenu);
			break;

		case WM_COMMAND:
			switch LOWORD(wParam)
			{
			case IDC_BUTTON :
				if(HIWORD(wParam) == BN_CLICKED)
				{
					TCHAR *tekst;
					int rozmiar = GetWindowTextLength(hEdit);
					tekst = (TCHAR*)GlobalAlloc(GPTR,  (rozmiar + 1) * sizeof(TCHAR));
					GetWindowText(hEdit, tekst, rozmiar + 1);
					SetWindowText(hStatic, tekst);
					GlobalFree(tekst);
				}

				break;
			case IDC_CHECKBOX:
				{
					LONG style;
					int stan = SendMessage(hCheckBox, BM_GETCHECK, 0, 0);

					if (stan == BST_CHECKED)
						SendMessage(hCheckBox, BM_SETCHECK, BST_UNCHECKED, 0);
					else
						SendMessage(hCheckBox, BM_SETCHECK, BST_CHECKED, 0);

					style = GetWindowLong(hButton, GWL_STYLE);
					style ^= WS_DISABLED;
					SetWindowLong(hButton, GWL_STYLE, style);
					InvalidateRect(hwnd, NULL, TRUE);
					break;
				}
			case IDM_NOWY:  	SetWindowText(hEdit, TEXT("")); break;
			case IDM_ZAMKNIJ:	SendMessage(hwnd, WM_CLOSE, 0, 0); break;
			case IDM_KOPIUJ:	SendMessage(hEdit, WM_COPY, 0, 0); break;
			case  IDM_WKLEJ:	SendMessage(hEdit, WM_PASTE, 0, 0); break;


			}
			
			break;
		case WM_RBUTTONDOWN:
		{
			SetForegroundWindow(hwnd);
			POINT point;
			GetCursorPos(&point);
			TrackPopupMenu(hSubMenu, TPM_BOTTOMALIGN | TPM_LEFTALIGN, point.x, point.y, 0, hwnd, NULL);
		}
			break;
        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;
        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wndClass;
	HWND hwnd;
	MSG Msg;

	ZeroMemory(&wndClass, sizeof(wndClass));
	wndClass.cbSize = sizeof(wndClass);
	wndClass.lpszClassName = TEXT("Klasa okien");
	wndClass.hInstance = hInstance;
	wndClass.lpfnWndProc = WndProc;
	wndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW);
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

	if (!RegisterClassEx(&wndClass))
	{
		MessageBox(NULL, TEXT("Bład rejestrowania klasy okna"), TEXT("Bład"), 
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}


	hwnd = CreateWindow(TEXT("Klasa okien"), TEXT("Witaj świecie"), WS_OVERLAPPEDWINDOW, 10, 10, 500, 600, 
		NULL, NULL, hInstance, NULL);

	if (hwnd == NULL)
	{
		MessageBox(NULL, TEXT("Błąd tworzenia okna!"), TEXT("Błąd"),
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	while(GetMessage(&Msg, NULL, 0, 0) > 0)
    {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
    }

	return Msg.wParam;
}